#!/usr/bin/python3

import sys
import os

sys.path.insert(0, "/home/caramellaio/code/RunlimPlotGenerator/src")

OLD_OCRA = "old_ocra"
NEW_OCRA = "new_ocra"
SMV_OCRA = "smv"
OPT_OCRA = "ltl"

OPT_REWR = "opt rewr"
OLD_REWR = "old rewr"
NEW_REWR = "new rewr"
SMV_REWR = "smv rewr"

def file2par(fname):
    str_v = os.path.basename(fname).split('-')[0]
    #str_v = os.path.basename(fname).split('-')[1].split('_')[0]

    return int(str_v)

def file2par2(fname):
    return os.path.basename(fname)

def file2comp(fname):
    fname = os.path.basename(fname)

    if OLD_OCRA in fname:
        return OLD_REWR
    elif NEW_OCRA in fname:
        return NEW_REWR
    elif OPT_OCRA in fname:
        return OPT_REWR
    elif SMV_OCRA in fname:
        return SMV_REWR
    else:
        print("Invalid file name: %s" % fname)
        exit(1)

if __name__ == "__main__":
    import runlim2py
    import plot
    import argparse


    parser = argparse.ArgumentParser(description="Plot pattern")

    parser.add_argument('-i', '--inp-folder', type=str, default=os.getcwd())
    parser.add_argument('-n', '--name', type=str, required=True)
    parser.add_argument('-m', '--multi-param', action='store_true', default=False)

    args = parser.parse_args()

    final = None

    final = runlim2py.expeval2py( args.inp_folder, args.name, True)

    if args.multi_param:
        plot_obj = plot.gen_obj_vals_from_runlim_obj(final, file2par2, file2comp, True, 14400)
    else:
        plot_obj = plot.gen_obj_vals_from_runlim_obj(final, file2par, file2comp, True, 14400)

    if args.multi_param:

        plot.incremental_plot(plot_obj, ["instance", "time (sec)"], "%s experimental evaluation" % args.name, 14400, "%s.png" % args.name)
    else:
        plot.single_param_plot(plot_obj, ["#n components", "time (sec)"], "%s experimental evaluation" % args.name, 14400, "%s.png" % args.name)
    print(plot_obj)

