#!/usr/bin/python3

import sys
import os

sys.path.insert(0, "plot_scripts")

OLD_OCRA = "old_ocra"
NEW_OCRA = "new_ocra"
SMV_OCRA = "smv_ocra"
SMV_OCRA2 = "smv"
OPT_OCRA = "opt_ocra"
OPT_OCRA2 = "ltl"

OPT_REWR = "opt rewr"
OLD_REWR = "old rewr"
NEW_REWR = "new rewr"
SMV_REWR = "smv rewr"

def file2par(fname):
    return fname.replace(OLD_OCRA, "").replace(NEW_OCRA, "").replace(OPT_OCRA, "") \
    .replace(SMV_OCRA, "").replace(OPT_OCRA2, "").replace(SMV_OCRA2, "")

def file2comp(fname):
    fname = os.path.basename(fname)

    if OLD_OCRA in fname:
        return OLD_REWR
    elif NEW_OCRA in fname:
        return NEW_REWR
    elif OPT_OCRA in fname or OPT_OCRA2 in fname:
        return OPT_REWR
    elif SMV_OCRA in fname or SMV_OCRA2 in fname:
        return SMV_REWR
    else:
        print("Invalid file name: %s" % fname)
        exit(1)

if __name__ == "__main__":
    import runlim2py
    import plot
    import argparse


    parser = argparse.ArgumentParser(description="Plot pattern")

    parser.add_argument('-i', '--inp-folder', type=str, default=os.getcwd())
    parser.add_argument('-n', '--name', type=str, required=True)

    args = parser.parse_args()

    final = runlim2py.expeval2py( args.inp_folder, args.name, True)

    print(final)
    plot_obj = plot.gen_obj_vals_from_runlim_obj(final, file2par, file2comp, True, 14400)

    plot_obj1 = None
    plot_obj2 = None

    for name in plot_obj:
        print(name)
        if name == NEW_REWR:
            assert (plot_obj1 == None)
            plot_obj1 = plot_obj[name]

        elif name == OPT_REWR:
            assert (plot_obj2 == None)
            plot_obj2 = plot_obj[name]



    assert(plot_obj1 and plot_obj2)
    print(plot_obj)

    plot.scatter_plot(plot_obj1, plot_obj2, "new rewriting", "optimized rewriting", "%s.png" % args.name)

